﻿Public Class FrmMain

	Private FrameCount As Integer = 0
	Private CurrentFrameIndex As Integer = 0
	Private Dimension As Drawing.Imaging.FrameDimension = Nothing

	Private Sub FrmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		Dimension = New Drawing.Imaging.FrameDimension(PicAnimatedGif.Image.FrameDimensionsList(0))
		FrameCount = PicAnimatedGif.Image.GetFrameCount(Dimension)
	End Sub

	Private Sub TmrAnimation_Tick(sender As Object, e As EventArgs) Handles TmrAnimation.Tick
		CurrentFrameIndex = (CurrentFrameIndex + 1) Mod FrameCount

		PicAnimatedGif.Image.SelectActiveFrame(Dimension, CurrentFrameIndex)
		PicAnimatedGif.Refresh()
	End Sub

	Private Sub FrmMain_MouseMove(sender As Object, e As MouseEventArgs) Handles Me.MouseMove
		If MouseIsOverPicBox(e) Then
			ResumeAnimation()
		Else
			StopAnimation()
		End If
	End Sub

	Private Function MouseIsOverPicBox(e As MouseEventArgs) As Boolean
		Return e.X >= PicAnimatedGif.Left AndAlso e.X <= PicAnimatedGif.Left + PicAnimatedGif.Width AndAlso e.Y >= PicAnimatedGif.Top AndAlso e.Y <= PicAnimatedGif.Top + PicAnimatedGif.Height
	End Function

	Private Sub ResumeAnimation()
		If TmrAnimation.Enabled Then Return

		TmrAnimation.Start()
	End Sub

	Private Sub StopAnimation()
		TmrAnimation.Stop()
	End Sub

End Class